/*
    QAD - Qt ADvanced

    Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CLINEEDIT_H
#define CLINEEDIT_H

#include "qad_widgets_export.h"

#include <QLineEdit>


class QAD_WIDGETS_EXPORT CLineEdit: public QLineEdit {
	Q_OBJECT
	Q_PROPERTY(QString defaultText READ defaultText WRITE setDefaultText)

public:
	explicit CLineEdit(QWidget * parent = nullptr);
	~CLineEdit() override;

	const QString & defaultText() const { return dt; }
	void setReadOnly(bool yes);

public slots:
	void clearClick();
	void setDefaultText(const QString & t, bool set_text = false);

signals:
	void cleared();

private slots:
	void clearMouseRelease(QMouseEvent * e);
	void textChangedInternal();

private:
	bool eventFilter(QObject * o, QEvent * e) override;
	void resizeEvent(QResizeEvent *) override;
	void changeEvent(QEvent * e) override;
	void cwPaintEvent();

	QWidget * cw;
	QString dt;
	QImage clear_im;
};

#endif // CLINEEDIT_H
